diff --git a/lib/automake.mk b/lib/automake.mk
index 211f3c0..3eae15b 100644
--- a/lib/automake.mk
+++ b/lib/automake.mk
@@ -110,7 +110,6 @@ lib_libopenvswitch_la_SOURCES = \
 	lib/learn.h \
 	lib/learning-switch.c \
 	lib/learning-switch.h \
-	lib/list.h \
 	lib/lockfile.c \
 	lib/lockfile.h \
 	lib/mac-learning.c \
diff --git a/lib/bfd.c b/lib/bfd.c
index c0e06af..909697f 100644
--- a/lib/bfd.c
+++ b/lib/bfd.c
@@ -30,7 +30,7 @@
 #include "flow.h"
 #include "hash.h"
 #include "hmap.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "netdev.h"
 #include "odp-util.h"
 #include "ofpbuf.h"
diff --git a/lib/dp-packet.h b/lib/dp-packet.h
index bf4e758..000b09d 100644
--- a/lib/dp-packet.h
+++ b/lib/dp-packet.h
@@ -19,7 +19,7 @@
 
 #include <stddef.h>
 #include <stdint.h>
-#include "list.h"
+#include "openvswitch/list.h"
 #include "packets.h"
 #include "util.h"
 #include "netdev-dpdk.h"
diff --git a/lib/dpif-netdev.c b/lib/dpif-netdev.c
index 0f2385a..8558732 100644
--- a/lib/dpif-netdev.c
+++ b/lib/dpif-netdev.c
@@ -44,7 +44,7 @@
 #include "flow.h"
 #include "hmapx.h"
 #include "latch.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "match.h"
 #include "netdev.h"
 #include "netdev-dpdk.h"
diff --git a/lib/fat-rwlock.c b/lib/fat-rwlock.c
index 89cff1d..b36cd4c 100644
--- a/lib/fat-rwlock.c
+++ b/lib/fat-rwlock.c
@@ -21,7 +21,7 @@
 #include <errno.h>
 
 #include "hmap.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "ovs-thread.h"
 #include "random.h"
 
diff --git a/lib/fat-rwlock.h b/lib/fat-rwlock.h
index 257cd56..181fa92 100644
--- a/lib/fat-rwlock.h
+++ b/lib/fat-rwlock.h
@@ -18,7 +18,7 @@
 #define FAT_RWLOCK_H 1
 
 #include "compiler.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "ovs-thread.h"
 
 /* "Fat rwlock".
diff --git a/lib/guarded-list.h b/lib/guarded-list.h
index 3e46d51..80ce22c 100644
--- a/lib/guarded-list.h
+++ b/lib/guarded-list.h
@@ -19,7 +19,7 @@
 
 #include <stddef.h>
 #include "compiler.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "ovs-thread.h"
 
 struct guarded_list {
diff --git a/lib/jsonrpc.c b/lib/jsonrpc.c
index 868dd40..33d23e1 100644
--- a/lib/jsonrpc.c
+++ b/lib/jsonrpc.c
@@ -24,7 +24,7 @@
 #include "openvswitch/dynamic-string.h"
 #include "fatal-signal.h"
 #include "json.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "ofpbuf.h"
 #include "ovs-thread.h"
 #include "poll-loop.h"
diff --git a/lib/list.h b/lib/list.h
deleted file mode 100644
index f641d39..0000000
--- a/lib/list.h
+++ /dev/null
@@ -1,23 +0,0 @@
-/*
- * Copyright (c) 2008, 2009, 2010, 2011, 2013, 2015 Nicira, Inc.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at:
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-#ifndef LIST_H
-#define LIST_H 1
-
-/* Doubly linked list. */
-
-#include "openvswitch/list.h"
-
-#endif /* list.h */
diff --git a/lib/lldp/aa-structs.h b/lib/lldp/aa-structs.h
index 473031e..0757293 100644
--- a/lib/lldp/aa-structs.h
+++ b/lib/lldp/aa-structs.h
@@ -21,7 +21,7 @@
 #define AA_STRUCTS_H
 
 #include <stdint.h>
-#include "list.h"
+#include "openvswitch/list.h"
 
 struct lldp_aa_element_system_id {
     struct eth_addr system_mac;
diff --git a/lib/lldp/lldpd.c b/lib/lldp/lldpd.c
index 71f7e44..da86083 100644
--- a/lib/lldp/lldpd.c
+++ b/lib/lldp/lldpd.c
@@ -39,7 +39,7 @@
 #include <sys/utsname.h>
 #endif
 #include "compiler.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "packets.h"
 #include "timeval.h"
 
diff --git a/lib/lldp/lldpd.h b/lib/lldp/lldpd.h
index c295ab4..fc2ae53 100644
--- a/lib/lldp/lldpd.h
+++ b/lib/lldp/lldpd.h
@@ -27,7 +27,7 @@
 #include <string.h>
 #include <sys/types.h>
 #include "dp-packet.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "lldpd-structs.h"
 #include "lldp-tlv.h"
 #include "packets.h"
diff --git a/lib/mac-learning.c b/lib/mac-learning.c
index f7c2781..6eda1fa 100644
--- a/lib/mac-learning.c
+++ b/lib/mac-learning.c
@@ -23,7 +23,7 @@
 #include "bitmap.h"
 #include "coverage.h"
 #include "hash.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "poll-loop.h"
 #include "timeval.h"
 #include "unaligned.h"
diff --git a/lib/mac-learning.h b/lib/mac-learning.h
index 1f41706..0b62d09 100644
--- a/lib/mac-learning.h
+++ b/lib/mac-learning.h
@@ -20,7 +20,7 @@
 #include <time.h>
 #include "heap.h"
 #include "hmap.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "ovs-atomic.h"
 #include "ovs-thread.h"
 #include "packets.h"
diff --git a/lib/mcast-snooping.c b/lib/mcast-snooping.c
index ee3e2e1..3560069 100644
--- a/lib/mcast-snooping.c
+++ b/lib/mcast-snooping.c
@@ -26,7 +26,7 @@
 #include "byte-order.h"
 #include "coverage.h"
 #include "hash.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "poll-loop.h"
 #include "timeval.h"
 #include "entropy.h"
diff --git a/lib/mcast-snooping.h b/lib/mcast-snooping.h
index 99c314d..84b9c57 100644
--- a/lib/mcast-snooping.h
+++ b/lib/mcast-snooping.h
@@ -22,7 +22,7 @@
 #include <time.h>
 #include "dp-packet.h"
 #include "hmap.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "ovs-atomic.h"
 #include "ovs-thread.h"
 #include "packets.h"
diff --git a/lib/netdev-dpdk.c b/lib/netdev-dpdk.c
index 6ac0eec..b3e4d49 100644
--- a/lib/netdev-dpdk.c
+++ b/lib/netdev-dpdk.c
@@ -34,7 +34,7 @@
 #include "dp-packet.h"
 #include "dpif-netdev.h"
 #include "fatal-signal.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "netdev-dpdk.h"
 #include "netdev-provider.h"
 #include "netdev-vport.h"
diff --git a/lib/netdev-dummy.c b/lib/netdev-dummy.c
index 27d718c..95b4c5f 100644
--- a/lib/netdev-dummy.c
+++ b/lib/netdev-dummy.c
@@ -24,7 +24,7 @@
 #include "dpif-netdev.h"
 #include "openvswitch/dynamic-string.h"
 #include "flow.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "netdev-provider.h"
 #include "netdev-vport.h"
 #include "odp-util.h"
diff --git a/lib/netdev-provider.h b/lib/netdev-provider.h
index 77aec4e..e083a90 100644
--- a/lib/netdev-provider.h
+++ b/lib/netdev-provider.h
@@ -21,7 +21,7 @@
 
 #include "connectivity.h"
 #include "netdev.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "ovs-numa.h"
 #include "packets.h"
 #include "seq.h"
diff --git a/lib/netdev-vport.c b/lib/netdev-vport.c
index 74442f4..20a2bf3 100644
--- a/lib/netdev-vport.c
+++ b/lib/netdev-vport.c
@@ -36,7 +36,7 @@
 #include "flow.h"
 #include "hash.h"
 #include "hmap.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "netdev-provider.h"
 #include "odp-netlink.h"
 #include "dp-packet.h"
diff --git a/lib/netdev.c b/lib/netdev.c
index 97beeeb..fdcf405 100644
--- a/lib/netdev.c
+++ b/lib/netdev.c
@@ -30,7 +30,7 @@
 #include "openvswitch/dynamic-string.h"
 #include "fatal-signal.h"
 #include "hash.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "netdev-dpdk.h"
 #include "netdev-provider.h"
 #include "netdev-vport.h"
diff --git a/lib/netlink-notifier.h b/lib/netlink-notifier.h
index 4bd90f1..da72fc7 100644
--- a/lib/netlink-notifier.h
+++ b/lib/netlink-notifier.h
@@ -20,7 +20,7 @@
 /* These functions are Linux specific, so they should be used directly only by
  * Linux-specific code. */
 
-#include "list.h"
+#include "openvswitch/list.h"
 
 struct nln;
 struct nln_notifier;
diff --git a/lib/ofp-util.h b/lib/ofp-util.h
index 31cbe2d..379257c 100644
--- a/lib/ofp-util.h
+++ b/lib/ofp-util.h
@@ -23,7 +23,7 @@
 #include "bitmap.h"
 #include "compiler.h"
 #include "flow.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "match.h"
 #include "meta-flow.h"
 #include "netdev.h"
diff --git a/lib/ofpbuf.h b/lib/ofpbuf.h
index 8008cb4..7a67d6f 100644
--- a/lib/ofpbuf.h
+++ b/lib/ofpbuf.h
@@ -19,7 +19,7 @@
 
 #include <stddef.h>
 #include <stdint.h>
-#include "list.h"
+#include "openvswitch/list.h"
 #include "packets.h"
 #include "util.h"
 
diff --git a/lib/ovs-lldp.c b/lib/ovs-lldp.c
index 4ad7467..b789677 100644
--- a/lib/ovs-lldp.c
+++ b/lib/ovs-lldp.c
@@ -36,7 +36,7 @@
 #include <sys/types.h>
 #include "openvswitch/dynamic-string.h"
 #include "flow.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "lldp/lldpd.h"
 #include "lldp/lldpd-structs.h"
 #include "netdev.h"
diff --git a/lib/ovs-lldp.h b/lib/ovs-lldp.h
index 71dff44..b5c3a48 100644
--- a/lib/ovs-lldp.h
+++ b/lib/ovs-lldp.h
@@ -22,7 +22,7 @@
 #include <stdint.h>
 #include "dp-packet.h"
 #include "hmap.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "lldp/lldpd.h"
 #include "ovs-atomic.h"
 #include "packets.h"
diff --git a/lib/ovs-numa.c b/lib/ovs-numa.c
index 2765ae2..b92522d 100644
--- a/lib/ovs-numa.c
+++ b/lib/ovs-numa.c
@@ -30,7 +30,7 @@
 
 #include "hash.h"
 #include "hmap.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "ovs-thread.h"
 #include "openvswitch/vlog.h"
 
diff --git a/lib/ovs-numa.h b/lib/ovs-numa.h
index 1435d3d..e7ff465 100644
--- a/lib/ovs-numa.h
+++ b/lib/ovs-numa.h
@@ -21,7 +21,7 @@
 #include <stdbool.h>
 
 #include "compiler.h"
-#include "list.h"
+#include "openvswitch/list.h"
 
 #define OVS_CORE_UNSPEC INT_MAX
 #define OVS_NUMA_UNSPEC INT_MAX
diff --git a/lib/ovs-rcu.c b/lib/ovs-rcu.c
index b8f8bc4..b71b075 100644
--- a/lib/ovs-rcu.c
+++ b/lib/ovs-rcu.c
@@ -18,7 +18,7 @@
 #include "ovs-rcu.h"
 #include "fatal-signal.h"
 #include "guarded-list.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "ovs-thread.h"
 #include "poll-loop.h"
 #include "seq.h"
diff --git a/lib/ovs-thread.c b/lib/ovs-thread.c
index 7777298..04677c6 100644
--- a/lib/ovs-thread.c
+++ b/lib/ovs-thread.c
@@ -26,7 +26,7 @@
 #include "compiler.h"
 #include "fatal-signal.h"
 #include "hash.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "netdev-dpdk.h"
 #include "ovs-rcu.h"
 #include "poll-loop.h"
diff --git a/lib/ovsdb-idl-provider.h b/lib/ovsdb-idl-provider.h
index 190acca..027f79b 100644
--- a/lib/ovsdb-idl-provider.h
+++ b/lib/ovsdb-idl-provider.h
@@ -17,7 +17,7 @@
 #define OVSDB_IDL_PROVIDER_H 1
 
 #include "hmap.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "ovsdb-idl.h"
 #include "ovsdb-types.h"
 #include "shash.h"
diff --git a/lib/poll-loop.c b/lib/poll-loop.c
index 9e06e0f..925198f 100644
--- a/lib/poll-loop.c
+++ b/lib/poll-loop.c
@@ -24,7 +24,7 @@
 #include "coverage.h"
 #include "openvswitch/dynamic-string.h"
 #include "fatal-signal.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "ovs-thread.h"
 #include "seq.h"
 #include "socket-util.h"
diff --git a/lib/process.c b/lib/process.c
index 7407b1e..5c257ed 100644
--- a/lib/process.c
+++ b/lib/process.c
@@ -28,7 +28,7 @@
 #include "coverage.h"
 #include "openvswitch/dynamic-string.h"
 #include "fatal-signal.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "ovs-thread.h"
 #include "poll-loop.h"
 #include "signals.h"
diff --git a/lib/rstp-common.h b/lib/rstp-common.h
index 7bbee4d..6d5acfc 100644
--- a/lib/rstp-common.h
+++ b/lib/rstp-common.h
@@ -34,7 +34,7 @@
 #include <stdbool.h>
 #include <stdint.h>
 #include "hmap.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "ovs-atomic.h"
 #include "packets.h"
 
diff --git a/lib/rtbsd.h b/lib/rtbsd.h
index d6b79f3..6676b9d 100644
--- a/lib/rtbsd.h
+++ b/lib/rtbsd.h
@@ -18,7 +18,7 @@
 #define RTBSD_H 1
 
 #include <net/if.h>
-#include "list.h"
+#include "openvswitch/list.h"
 
 /*
  * A digested version of a message received from a PF_ROUTE socket which
diff --git a/lib/seq.c b/lib/seq.c
index 9c3257c..7043405 100644
--- a/lib/seq.c
+++ b/lib/seq.c
@@ -24,7 +24,7 @@
 #include "hash.h"
 #include "hmap.h"
 #include "latch.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "ovs-thread.h"
 #include "poll-loop.h"
 
diff --git a/lib/tnl-ports.c b/lib/tnl-ports.c
index a2a42cc..72aa9f2 100644
--- a/lib/tnl-ports.c
+++ b/lib/tnl-ports.c
@@ -25,7 +25,7 @@
 #include "classifier.h"
 #include "openvswitch/dynamic-string.h"
 #include "hash.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "netdev.h"
 #include "ofpbuf.h"
 #include "ovs-thread.h"
diff --git a/lib/unixctl.c b/lib/unixctl.c
index 30fcc69..c91dd0a 100644
--- a/lib/unixctl.c
+++ b/lib/unixctl.c
@@ -23,7 +23,7 @@
 #include "openvswitch/dynamic-string.h"
 #include "json.h"
 #include "jsonrpc.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "poll-loop.h"
 #include "shash.h"
 #include "stream.h"
diff --git a/ofproto/bond.c b/ofproto/bond.c
index d82cf75..534ed28 100644
--- a/ofproto/bond.c
+++ b/ofproto/bond.c
@@ -35,7 +35,7 @@
 #include "flow.h"
 #include "hmap.h"
 #include "lacp.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "netdev.h"
 #include "odp-util.h"
 #include "ofpbuf.h"
diff --git a/ofproto/connmgr.h b/ofproto/connmgr.h
index dfc06e3..637ad17 100644
--- a/ofproto/connmgr.h
+++ b/ofproto/connmgr.h
@@ -19,7 +19,7 @@
 
 #include "classifier.h"
 #include "hmap.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "match.h"
 #include "ofp-util.h"
 #include "ofproto.h"
diff --git a/ofproto/ofproto-dpif-ipfix.c b/ofproto/ofproto-dpif-ipfix.c
index a610c53..9d605b2 100644
--- a/ofproto/ofproto-dpif-ipfix.c
+++ b/ofproto/ofproto-dpif-ipfix.c
@@ -22,7 +22,7 @@
 #include "flow.h"
 #include "hash.h"
 #include "hmap.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "ofpbuf.h"
 #include "ofproto.h"
 #include "ofproto-dpif.h"
diff --git a/ofproto/ofproto-dpif-rid.h b/ofproto/ofproto-dpif-rid.h
index 8ada532..287663a 100644
--- a/ofproto/ofproto-dpif-rid.h
+++ b/ofproto/ofproto-dpif-rid.h
@@ -21,7 +21,7 @@
 #include <stdint.h>
 
 #include "cmap.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "ofp-actions.h"
 #include "ofproto-dpif-mirror.h"
 #include "ovs-thread.h"
diff --git a/ofproto/ofproto-dpif-upcall.c b/ofproto/ofproto-dpif-upcall.c
index bc316e4..9c64b6b 100644
--- a/ofproto/ofproto-dpif-upcall.c
+++ b/ofproto/ofproto-dpif-upcall.c
@@ -27,7 +27,7 @@
 #include "fail-open.h"
 #include "guarded-list.h"
 #include "latch.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "netlink.h"
 #include "ofpbuf.h"
 #include "ofproto-dpif-ipfix.h"
diff --git a/ofproto/ofproto-dpif-xlate.c b/ofproto/ofproto-dpif-xlate.c
index 67504e8..20b2069 100644
--- a/ofproto/ofproto-dpif-xlate.c
+++ b/ofproto/ofproto-dpif-xlate.c
@@ -37,7 +37,7 @@
 #include "in-band.h"
 #include "lacp.h"
 #include "learn.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "ovs-lldp.h"
 #include "mac-learning.h"
 #include "mcast-snooping.h"
diff --git a/ofproto/ofproto-provider.h b/ofproto/ofproto-provider.h
index 5938ba6..9373a2c 100644
--- a/ofproto/ofproto-provider.h
+++ b/ofproto/ofproto-provider.h
@@ -38,7 +38,7 @@
 #include "guarded-list.h"
 #include "heap.h"
 #include "hindex.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "ofp-actions.h"
 #include "ofp-util.h"
 #include "ofproto/ofproto.h"
diff --git a/ovn/lib/expr.h b/ovn/lib/expr.h
index de27f09..fa7ccbe 100644
--- a/ovn/lib/expr.h
+++ b/ovn/lib/expr.h
@@ -55,7 +55,7 @@
 #include "classifier.h"
 #include "lex.h"
 #include "hmap.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "match.h"
 #include "meta-flow.h"
 
diff --git a/ovsdb/ovsdb-server.c b/ovsdb/ovsdb-server.c
index 459a0dd..4e2c8d0 100644
--- a/ovsdb/ovsdb-server.c
+++ b/ovsdb/ovsdb-server.c
@@ -33,7 +33,7 @@
 #include "json.h"
 #include "jsonrpc.h"
 #include "jsonrpc-server.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "memory.h"
 #include "monitor.h"
 #include "ovsdb.h"
diff --git a/ovsdb/ovsdb.h b/ovsdb/ovsdb.h
index 04586e7..b3eaf15 100644
--- a/ovsdb/ovsdb.h
+++ b/ovsdb/ovsdb.h
@@ -18,7 +18,7 @@
 
 #include "compiler.h"
 #include "hmap.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "shash.h"
 
 struct json;
diff --git a/ovsdb/row.h b/ovsdb/row.h
index 62820d5..b1d1edd 100644
--- a/ovsdb/row.h
+++ b/ovsdb/row.h
@@ -20,7 +20,7 @@
 #include <stdint.h>
 #include "column.h"
 #include "hmap.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "ovsdb-data.h"
 
 struct ovsdb_column_set;
diff --git a/ovsdb/server.h b/ovsdb/server.h
index 82c733f..667fce9 100644
--- a/ovsdb/server.h
+++ b/ovsdb/server.h
@@ -17,7 +17,7 @@
 #define SERVER_H 1
 
 #include "hmap.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "shash.h"
 
 struct ovsdb;
diff --git a/ovsdb/transaction.c b/ovsdb/transaction.c
index 09abdcb..725c6f5 100644
--- a/ovsdb/transaction.c
+++ b/ovsdb/transaction.c
@@ -22,7 +22,7 @@
 #include "hash.h"
 #include "hmap.h"
 #include "json.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "ovsdb-error.h"
 #include "ovsdb.h"
 #include "row.h"
diff --git a/ovsdb/trigger.h b/ovsdb/trigger.h
index 823ea9b..867a28c 100644
--- a/ovsdb/trigger.h
+++ b/ovsdb/trigger.h
@@ -16,7 +16,7 @@
 #ifndef OVSDB_TRIGGER_H
 #define OVSDB_TRIGGER_H 1
 
-#include "list.h"
+#include "openvswitch/list.h"
 
 struct ovsdb;
 
diff --git a/tests/test-list.c b/tests/test-list.c
index 9b6b0bd..7789dac 100644
--- a/tests/test-list.c
+++ b/tests/test-list.c
@@ -15,11 +15,11 @@
  */
 
 /* A non-exhaustive test for some of the functions and macros declared in
- * list.h. */
+ * openvswitch/list.h. */
 
 #include <config.h>
 #undef NDEBUG
-#include "list.h"
+#include "openvswitch/list.h"
 #include <assert.h>
 #include <string.h>
 #include "ovstest.h"
diff --git a/vswitchd/bridge.c b/vswitchd/bridge.c
index d6c3600..0e884fe 100644
--- a/vswitchd/bridge.c
+++ b/vswitchd/bridge.c
@@ -34,7 +34,7 @@
 #include "hmapx.h"
 #include "jsonrpc.h"
 #include "lacp.h"
-#include "list.h"
+#include "openvswitch/list.h"
 #include "ovs-lldp.h"
 #include "mac-learning.h"
 #include "mcast-snooping.h"