diff --git a/lib/automake.mk b/lib/automake.mk
index bcc7813..d06fc8b 100644
--- a/lib/automake.mk
+++ b/lib/automake.mk
@@ -353,6 +353,8 @@ lib_libopenvswitch_la_SOURCES += \
 	lib/dpif-netlink.h \
 	lib/tc.h \
 	lib/tc.c \
+	lib/netdev-tc-offloads.h \
+	lib/netdev-tc-offloads.c \
 	lib/if-notifier.c \
 	lib/if-notifier.h \
 	lib/netdev-linux.c \
diff --git a/lib/netdev-bsd.c b/lib/netdev-bsd.c
index 75a330b..d61c229 100644
--- a/lib/netdev-bsd.c
+++ b/lib/netdev-bsd.c
@@ -1543,6 +1543,15 @@ netdev_bsd_update_flags(struct netdev *netdev_, enum netdev_flags off,
     netdev_bsd_rxq_recv,                             \
     netdev_bsd_rxq_wait,                             \
     netdev_bsd_rxq_drain,                            \
+                                                     \
+    NULL, /* flow_flush */                           \
+    NULL, /* flow_dump_create */                     \
+    NULL, /* flow_dump_destroy */                    \
+    NULL, /* flow_dump_next */                       \
+    NULL, /* flow_put */                             \
+    NULL, /* flow_get */                             \
+    NULL, /* flow_del */                             \
+    NULL, /* init_flow_api */                        \
 }
 
 const struct netdev_class netdev_bsd_class =
diff --git a/lib/netdev-dummy.c b/lib/netdev-dummy.c
index dec1a8e..9408cc4 100644
--- a/lib/netdev-dummy.c
+++ b/lib/netdev-dummy.c
@@ -1384,6 +1384,15 @@ netdev_dummy_update_flags(struct netdev *netdev_,
     netdev_dummy_rxq_recv,                                      \
     netdev_dummy_rxq_wait,                                      \
     netdev_dummy_rxq_drain,                                     \
+                                                                \
+    NULL,                       /* flow_flush */                \
+    NULL,                       /* flow_dump_create */          \
+    NULL,                       /* flow_dump_destroy */         \
+    NULL,                       /* flow_dump_next */            \
+    NULL,                       /* flow_put */                  \
+    NULL,                       /* flow_get */                  \
+    NULL,                       /* flow_del */                  \
+    NULL,                       /* init_flow_api */             \
 }
 
 static const struct netdev_class dummy_class =
diff --git a/lib/netdev-linux.c b/lib/netdev-linux.c
index a5a9ec1..6a23a82 100644
--- a/lib/netdev-linux.c
+++ b/lib/netdev-linux.c
@@ -74,6 +74,7 @@
 #include "unaligned.h"
 #include "openvswitch/vlog.h"
 #include "util.h"
+#include "netdev-tc-offloads.h"
 
 VLOG_DEFINE_THIS_MODULE(netdev_linux);
 
@@ -2762,7 +2763,8 @@ netdev_linux_update_flags(struct netdev *netdev_, enum netdev_flags off,
 }
 
 #define NETDEV_LINUX_CLASS(NAME, CONSTRUCT, GET_STATS,          \
-                           GET_FEATURES, GET_STATUS)            \
+                           GET_FEATURES, GET_STATUS,            \
+                           FLOW_OFFLOAD_API)                    \
 {                                                               \
     NAME,                                                       \
     false,                      /* is_pmd */                    \
@@ -2831,15 +2833,29 @@ netdev_linux_update_flags(struct netdev *netdev_, enum netdev_flags off,
     netdev_linux_rxq_recv,                                      \
     netdev_linux_rxq_wait,                                      \
     netdev_linux_rxq_drain,                                     \
+                                                                \
+    FLOW_OFFLOAD_API                                            \
 }
 
+#define NO_OFFLOAD_API NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL
+#define LINUX_OFFLOAD                                           \
+            netdev_tc_flow_flush,                               \
+            netdev_tc_flow_dump_create,                         \
+            netdev_tc_flow_dump_destroy,                        \
+            netdev_tc_flow_dump_next,                           \
+            netdev_tc_flow_put,                                 \
+            netdev_tc_flow_get,                                 \
+            netdev_tc_flow_del,                                 \
+            netdev_tc_init_flow_api
+
 const struct netdev_class netdev_linux_class =
     NETDEV_LINUX_CLASS(
         "system",
         netdev_linux_construct,
         netdev_linux_get_stats,
         netdev_linux_get_features,
-        netdev_linux_get_status);
+        netdev_linux_get_status,
+        LINUX_OFFLOAD);
 
 const struct netdev_class netdev_tap_class =
     NETDEV_LINUX_CLASS(
@@ -2847,7 +2863,8 @@ const struct netdev_class netdev_tap_class =
         netdev_linux_construct_tap,
         netdev_tap_get_stats,
         netdev_linux_get_features,
-        netdev_linux_get_status);
+        netdev_linux_get_status,
+        NO_OFFLOAD_API);
 
 const struct netdev_class netdev_internal_class =
     NETDEV_LINUX_CLASS(
@@ -2855,7 +2872,8 @@ const struct netdev_class netdev_internal_class =
         netdev_linux_construct,
         netdev_internal_get_stats,
         NULL,                  /* get_features */
-        netdev_internal_get_status);
+        netdev_internal_get_status,
+        NO_OFFLOAD_API);
 
 
 #define CODEL_N_QUEUES 0x0000
diff --git a/lib/netdev-provider.h b/lib/netdev-provider.h
index c8507a5..bdbc5e9 100644
--- a/lib/netdev-provider.h
+++ b/lib/netdev-provider.h
@@ -115,6 +115,14 @@ struct netdev_rxq {
 
 struct netdev *netdev_rxq_get_netdev(const struct netdev_rxq *);
 
+
+struct netdev_flow_dump {
+    struct netdev *netdev;
+    odp_port_t port;
+    struct nl_dump *nl_dump;
+    bool terse;
+};
+
 /* Network device class structure, to be defined by each implementation of a
  * network device.
  *
@@ -764,6 +772,27 @@ struct netdev_class {
 
     /* Discards all packets waiting to be received from 'rx'. */
     int (*rxq_drain)(struct netdev_rxq *rx);
+
+/* ## -------------------------------- ## */
+/* ## netdev flow offloading functions ## */
+/* ## -------------------------------- ## */
+
+/* If a particular netdev class does not support offloading flows, all these
+ * function pointers must be NULL. */
+
+    int (*flow_flush)(struct netdev *);
+    struct netdev_flow_dump *(*flow_dump_create)(struct netdev *);
+    int (*flow_dump_destroy)(struct netdev_flow_dump *);
+    bool (*flow_dump_next)(struct netdev_flow_dump *, struct match *,
+                           struct nlattr **actions,
+                           struct dpif_flow_stats *stats, ovs_u128 *ufid,
+                           struct ofpbuf *rbuffer, struct ofpbuf *wbuffer);
+    int (*flow_put)(struct netdev *, struct match *, struct nlattr *actions,
+                    size_t actions_len, struct dpif_flow_stats *, ovs_u128 *);
+    int (*flow_get)(struct netdev *, struct match *, struct nlattr **actions,
+                    struct dpif_flow_stats *, ovs_u128 *, struct ofpbuf *);
+    int (*flow_del)(struct netdev *, struct dpif_flow_stats *, ovs_u128 *);
+    int (*init_flow_api)(struct netdev *);
 };
 
 int netdev_register_provider(const struct netdev_class *);
diff --git a/lib/netdev-tc-offloads.c b/lib/netdev-tc-offloads.c
new file mode 100644
index 0000000..692ab76
--- /dev/null
+++ b/lib/netdev-tc-offloads.c
@@ -0,0 +1,149 @@
+/*
+ * Copyright (c) 2016 Mellanox Technologies, Ltd.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at:
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#include <config.h>
+
+#include "netdev-tc-offloads.h"
+
+#include <errno.h>
+#include <fcntl.h>
+#include <arpa/inet.h>
+#include <inttypes.h>
+#include <linux/filter.h>
+#include <linux/gen_stats.h>
+#include <linux/if_ether.h>
+#include <linux/if_tun.h>
+#include <linux/types.h>
+#include <linux/ethtool.h>
+#include <linux/mii.h>
+#include <linux/pkt_cls.h>
+#include <linux/pkt_sched.h>
+#include <linux/rtnetlink.h>
+#include <linux/sockios.h>
+#include <sys/types.h>
+#include <sys/ioctl.h>
+#include <sys/socket.h>
+#include <sys/utsname.h>
+#include <netpacket/packet.h>
+#include <net/if.h>
+#include <net/if_arp.h>
+#include <net/if_packet.h>
+#include <net/route.h>
+#include <netinet/in.h>
+#include <poll.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+
+#include "coverage.h"
+#include "dp-packet.h"
+#include "dpif-netlink.h"
+#include "dpif-netdev.h"
+#include "openvswitch/dynamic-string.h"
+#include "fatal-signal.h"
+#include "hash.h"
+#include "openvswitch/hmap.h"
+#include "netdev-provider.h"
+#include "netdev-vport.h"
+#include "netlink-notifier.h"
+#include "netlink-socket.h"
+#include "netlink.h"
+#include "openvswitch/ofpbuf.h"
+#include "openflow/openflow.h"
+#include "ovs-atomic.h"
+#include "packets.h"
+#include "poll-loop.h"
+#include "rtnetlink.h"
+#include "openvswitch/shash.h"
+#include "netdev-provider.h"
+#include "openvswitch/match.h"
+#include "openvswitch/vlog.h"
+#include "tc.h"
+
+VLOG_DEFINE_THIS_MODULE(netdev_tc_offloads);
+
+int
+netdev_tc_flow_flush(struct netdev *netdev OVS_UNUSED)
+{
+    return EOPNOTSUPP;
+}
+
+struct netdev_flow_dump *
+netdev_tc_flow_dump_create(struct netdev *netdev)
+{
+    struct netdev_flow_dump *dump = xzalloc(sizeof *dump);
+
+    dump->netdev = netdev_ref(netdev);
+    return dump;
+}
+
+int
+netdev_tc_flow_dump_destroy(struct netdev_flow_dump *dump)
+{
+    netdev_close(dump->netdev);
+    free(dump);
+
+    return 0;
+}
+
+bool
+netdev_tc_flow_dump_next(struct netdev_flow_dump *dump OVS_UNUSED,
+                            struct match *match OVS_UNUSED,
+                            struct nlattr **actions OVS_UNUSED,
+                            struct dpif_flow_stats *stats OVS_UNUSED,
+                            ovs_u128 *ufid OVS_UNUSED,
+                            struct ofpbuf *rbuffer OVS_UNUSED,
+                            struct ofpbuf *wbuffer OVS_UNUSED)
+{
+    return false;
+}
+
+int
+netdev_tc_flow_put(struct netdev *netdev OVS_UNUSED,
+                      struct match *match OVS_UNUSED,
+                      struct nlattr *actions OVS_UNUSED,
+                      size_t actions_len OVS_UNUSED,
+                      struct dpif_flow_stats *stats OVS_UNUSED,
+                      ovs_u128 *ufid OVS_UNUSED)
+{
+    return EOPNOTSUPP;
+}
+
+int
+netdev_tc_flow_get(struct netdev *netdev OVS_UNUSED,
+                      struct match *match OVS_UNUSED,
+                      struct nlattr **actions OVS_UNUSED,
+                      struct dpif_flow_stats *stats OVS_UNUSED,
+                      ovs_u128 *ufid OVS_UNUSED,
+                      struct ofpbuf *buf OVS_UNUSED)
+{
+    return EOPNOTSUPP;
+}
+
+int
+netdev_tc_flow_del(struct netdev *netdev OVS_UNUSED,
+                      struct dpif_flow_stats *stats OVS_UNUSED,
+                      ovs_u128 *ufid OVS_UNUSED)
+{
+    return EOPNOTSUPP;
+}
+
+int
+netdev_tc_init_flow_api(struct netdev *netdev OVS_UNUSED)
+{
+    return 0;
+}
+
diff --git a/lib/netdev-tc-offloads.h b/lib/netdev-tc-offloads.h
new file mode 100644
index 0000000..0054bb6
--- /dev/null
+++ b/lib/netdev-tc-offloads.h
@@ -0,0 +1,40 @@
+/*
+ * Copyright (c) 2016 Mellanox Technologies, Ltd.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at:
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef NETDEV_TC_OFFLOADS_H
+#define NETDEV_TC_OFFLOADS_H 1
+
+#include "netdev.h"
+
+int netdev_tc_flow_flush(struct netdev *);
+struct netdev_flow_dump *netdev_tc_flow_dump_create(struct netdev *);
+int netdev_tc_flow_dump_destroy(struct netdev_flow_dump *);
+bool netdev_tc_flow_dump_next(struct netdev_flow_dump *, struct match *,
+                              struct nlattr **actions,
+                              struct dpif_flow_stats *,
+                              ovs_u128 *ufid,
+                              struct ofpbuf *rbuffer, struct ofpbuf *wbuffer);
+int netdev_tc_flow_put(struct netdev *, struct match *,
+                       struct nlattr *actions,
+                       size_t actions_len,
+                       struct dpif_flow_stats *, ovs_u128 *);
+int netdev_tc_flow_get(struct netdev *, struct match *,
+                       struct nlattr **actions, struct dpif_flow_stats *,
+                       ovs_u128 *, struct ofpbuf *);
+int netdev_tc_flow_del(struct netdev *, struct dpif_flow_stats *, ovs_u128 *);
+int netdev_tc_init_flow_api(struct netdev *);
+
+#endif /* netdev-tc-offloads.h */
diff --git a/lib/netdev-vport.c b/lib/netdev-vport.c
index 02a246a..2cde854 100644
--- a/lib/netdev-vport.c
+++ b/lib/netdev-vport.c
@@ -810,7 +810,16 @@ get_stats(const struct netdev *netdev, struct netdev_stats *stats)
     NULL,                   /* rx_dealloc */                \
     NULL,                   /* rx_recv */                   \
     NULL,                   /* rx_wait */                   \
-    NULL,                   /* rx_drain */
+    NULL,                   /* rx_drain */                  \
+                                                            \
+    NULL,                   /* flow_flush */                \
+    NULL,                   /* flow_dump_create */          \
+    NULL,                   /* flow_dump_destroy */         \
+    NULL,                   /* flow_dump_next */            \
+    NULL,                   /* flow_put */                  \
+    NULL,                   /* flow_get */                  \
+    NULL,                   /* flow_del */                  \
+    NULL,                   /* init_flow_api */
 
 
 #define TUNNEL_CLASS(NAME, DPIF_PORT, BUILD_HEADER, PUSH_HEADER, POP_HEADER)   \
diff --git a/lib/netdev.c b/lib/netdev.c
index 860781d..3ac3c48 100644
--- a/lib/netdev.c
+++ b/lib/netdev.c
@@ -1973,3 +1973,105 @@ netdev_reconfigure(struct netdev *netdev)
             ? class->reconfigure(netdev)
             : EOPNOTSUPP);
 }
+
+int
+netdev_flow_flush(struct netdev *netdev)
+{
+    const struct netdev_class *class = netdev->netdev_class;
+
+    return (class->flow_flush
+            ? class->flow_flush(netdev)
+            : EOPNOTSUPP);
+}
+
+struct netdev_flow_dump *
+netdev_flow_dump_create(struct netdev *netdev)
+{
+    const struct netdev_class *class = netdev->netdev_class;
+    struct netdev_flow_dump *dump;
+
+    if (class->flow_dump_create) {
+        return class->flow_dump_create(netdev);
+    }
+
+    dump = xzalloc(sizeof *dump);
+    dump->netdev = netdev;
+
+    return dump;
+}
+
+int
+netdev_flow_dump_destroy(struct netdev_flow_dump *dump)
+{
+    const struct netdev_class *class = dump->netdev->netdev_class;
+
+    if (class->flow_dump_destroy) {
+        return class->flow_dump_destroy(dump);
+    }
+
+    free(dump);
+
+    return EOPNOTSUPP;
+}
+
+bool
+netdev_flow_dump_next(struct netdev_flow_dump *dump,
+                      struct match *match,
+                      struct nlattr **actions,
+                      struct dpif_flow_stats *stats,
+                      ovs_u128 *ufid,
+                      struct ofpbuf *rbuffer,
+                      struct ofpbuf *wbuffer)
+{
+    const struct netdev_class *class = dump->netdev->netdev_class;
+
+    return (class->flow_dump_next
+            ? class->flow_dump_next(dump, match, actions, stats, ufid,
+                                    rbuffer, wbuffer)
+            : false);
+}
+
+int
+netdev_flow_put(struct netdev *netdev, struct match *match,
+                struct nlattr *actions, size_t act_len,
+                struct dpif_flow_stats *stats, ovs_u128 *ufid)
+{
+    const struct netdev_class *class = netdev->netdev_class;
+
+    return (class->flow_put
+            ? class->flow_put(netdev, match, actions, act_len, stats, ufid)
+            : EOPNOTSUPP);
+}
+
+int
+netdev_flow_get(struct netdev *netdev, struct match *match,
+                struct nlattr **actions, struct dpif_flow_stats *stats,
+                ovs_u128 *ufid, struct ofpbuf *buf)
+{
+    const struct netdev_class *class = netdev->netdev_class;
+
+    return (class->flow_get
+            ? class->flow_get(netdev, match, actions, stats, ufid, buf)
+            : EOPNOTSUPP);
+}
+
+int
+netdev_flow_del(struct netdev *netdev, struct dpif_flow_stats *stats,
+                ovs_u128 *ufid)
+{
+    const struct netdev_class *class = netdev->netdev_class;
+
+    return (class->flow_del
+            ? class->flow_del(netdev, stats, ufid)
+            : EOPNOTSUPP);
+}
+
+int
+netdev_init_flow_api(struct netdev *netdev)
+{
+    const struct netdev_class *class = netdev->netdev_class;
+
+    return (class->init_flow_api
+            ? class->init_flow_api(netdev)
+            : EOPNOTSUPP);
+}
diff --git a/lib/netdev.h b/lib/netdev.h
index bad28c4..c04632d 100644
--- a/lib/netdev.h
+++ b/lib/netdev.h
@@ -153,6 +153,22 @@ int netdev_send(struct netdev *, int qid, struct dp_packet_batch *,
                 bool may_steal, bool concurrent_txq);
 void netdev_send_wait(struct netdev *, int qid);
 
+/* Flow offloading. */
+struct netdev_flow_dump;
+int netdev_flow_flush(struct netdev *);
+struct netdev_flow_dump *netdev_flow_dump_create(struct netdev *);
+int netdev_flow_dump_destroy(struct netdev_flow_dump *);
+bool netdev_flow_dump_next(struct netdev_flow_dump *, struct match *,
+                          struct nlattr **actions, struct dpif_flow_stats *,
+                          ovs_u128 *ufid, struct ofpbuf *rbuffer,
+                          struct ofpbuf *wbuffer);
+int netdev_flow_put(struct netdev *, struct match *, struct nlattr *actions,
+                    size_t actions_len, struct dpif_flow_stats *, ovs_u128 *);
+int netdev_flow_get(struct netdev *, struct match *, struct nlattr **actions,
+                    struct dpif_flow_stats *, ovs_u128 *, struct ofpbuf *);
+int netdev_flow_del(struct netdev *, struct dpif_flow_stats *, ovs_u128 *);
+int netdev_init_flow_api(struct netdev *);
+
 /* native tunnel APIs */
 /* Structure to pass parameters required to build a tunnel header. */
 struct netdev_tnl_build_header_params {